﻿using System;
using PSTech;

namespace Client.NET
{
    class Client
    {
        unsafe static int Main(string[] args)
        {
            if (PSTAPI.pst_connect() == 0)
            {
                System.Console.WriteLine("pst_connect failed, is the Personal Space Tracker client program running?");
                System.Console.WriteLine("Press any key to exit...");
                System.Console.ReadKey(true);
                return 1;
            }

            PSTSensor sensor = new PSTSensor();
            PSTPoint point = new PSTPoint();

            while (true)
            {                
                while (PSTAPI.pst_get_sensor(ref sensor) != 0)
                {
                    System.Console.WriteLine("SENSOR name = " + new String((sbyte*)sensor.name) + ", id = " + sensor.id);

                    for (int i = 0; i < 4; ++i)
                    {
                        for (int j = 0; j < 4; ++j)
                        {
                            System.Console.Write(sensor.pose[i * 4 + j] + " ");
                        }
                        System.Console.WriteLine();
                    }

                    System.Console.WriteLine();
                }

                while (PSTAPI.pst_get_point(ref point) != 0)
                {
                    System.Console.WriteLine("POINT id = " + point.id);

                    for (int i = 0; i < 3; ++i)
                        System.Console.Write(point.pos[i] + " ");

                    System.Console.WriteLine();
                }

                System.Threading.Thread.Sleep(1000);
            }

            PSTAPI.pst_disconnect();

            return 0;
        }
    }
}
