﻿// Compile with /unsafe

using System;
using System.Runtime.InteropServices;

namespace PSTech
{
    /**
     * Holds an estimated device pose. 
     */
    unsafe public struct PSTSensor
    {
        public fixed byte  name[80];  /**< Device name */
        public int id;                /**< Device identifier (for other tracking interfaces */
        public fixed float pose[16];  /**< Device pose estimate as row-major matrix */
        public double timestamp;      /**< Time the data was recorded */
    }

    /**
     * Hold an estimated 3D marker location.
     */
    unsafe public struct PSTPoint
    {
        public int id;             /**< Marker identifier */
        public fixed float pos[3]; /**< Estimated marker location */
        public double timestamp;   /**< Time the data was recorded */
    }
 
    public class PSTAPI
    {
        [DllImport("pst.dll",CallingConvention=CallingConvention.Cdecl)]
        public static extern int pst_connect();

        [DllImport("pst.dll",CallingConvention=CallingConvention.Cdecl)]
        public static extern int pst_disconnect();

        [DllImport("pst.dll",CallingConvention=CallingConvention.Cdecl)]
        public static extern int pst_sensor_changed();
        
        [DllImport("pst.dll",CallingConvention=CallingConvention.Cdecl)]
        public static extern int pst_sensor_changed_by_id(int id);
        
        [DllImport("pst.dll",CallingConvention=CallingConvention.Cdecl)]
        public static extern int pst_get_sensor (ref PSTSensor sensor);

        [DllImport("pst.dll",CallingConvention=CallingConvention.Cdecl)]
        public static extern int pst_get_sensor_by_id (int id, ref PSTSensor sensor);

        [DllImport("pst.dll",CallingConvention=CallingConvention.Cdecl)]
        public static extern int pst_point_changed();

        [DllImport("pst.dll",CallingConvention=CallingConvention.Cdecl)]
        public static extern int pst_get_point (ref PSTPoint point);
    }
}
