from ctypes import *

class PSTSensor(Structure):
	_fields_ = [("name", c_char * 80),
				("id", c_int),
				("pose", c_float * 16),
				("timestamp", c_double)]
				
class PSTPoint(Structure):
	_fields_ = 	[("id", c_int),
				("pos", c_float * 3),
				("timestamp", c_double)]				

_pst_instance = cdll.pst

def pst_connect():
	return _pst_instance.pst_connect()

def pst_disconnect():
	return _pst_instance.pst_disconnect()

def pst_sensor_changed():
	return _pst_instance.pst_sensor_changed()

def pst_sensor_changed_by_id(id):
	return _pst_instance.pst_sensor_changed_by_id(id)

def pst_get_sensor(sensor):
	return _pst_instance.pst_get_sensor(byref(sensor))

def pst_get_sensor_by_id(id, sensor):
	return _pst_instance.pst_get_sensor_by_id(id, byref(sensor))

def pst_point_changed():
	return _pst_instance.pst_point_changed()

def pst_get_point(point):
	return _pst_instance.pst_get_point(byref(point))
